# Copyright (c) 2000-2013, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define reltag _redhat_3
%define namedreltag -redhat-3
%global namedversion %{version}%{?namedreltag}

%define maven_version 1.4.2-redhat-3

Name:           openws
Version:        1.4.2
Release:        9%{?reltag}%{?dist}
Epoch:          0
Summary:        Open WS
License:        ASL 2.0
Group:          Development/Java

%if %with mead
Source100: org.opensaml-openws-1.4.2-redhat-3-sources.zip
Source101: org.opensaml-openws-1.4.2-redhat-3-patches.zip
Source102: openws-1.4.2-redhat-3.jar
Source103: openws-1.4.2-redhat-3-src.tar.gz
Source104: openws-1.4.2-redhat-3-bin.tar.gz
Source105: openws-1.4.2-redhat-3.pom
Source106: openws-1.4.2-redhat-3-sources.jar
Source107: openws-1.4.2-redhat-3-src.zip
Source108: openws-1.4.2-redhat-3-bin.zip
Source109: openws-1.4.2-redhat-3-javadoc.jar
%endif

URL:            http://www.opensaml.org/
%if 0
svn -q export -r 419 https://svn.shibboleth.net/java-openws/tags/1.4.2/ openws-1.4.2 && tar czf openws-1.4.2.tar.gz openws-1.4.2/
%endif
%if %without mead
Source0:        openws-1.4.2.tar.gz
Patch0:         000-openws-pom.patch
Patch1:         001-openws-vman.patch
Patch2:         002-openws-assembly.patch
%endif
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
Requires:       xmltooling
%if %without mead
# FIXME: slf4j package split; all actually come from xmltooling:
BuildRequires:  slf4j-api
BuildRequires:  jcl-over-slf4j
BuildRequires:  log4j-over-slf4j
BuildRequires:  jul-to-slf4j
#
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  commons-httpclient
BuildRequires:  jboss-servlet-api_3.0_spec
BuildRequires:  junit
# XXX: disabling tests to disable spring 2.x (not in EAP 6)
%if 0
BuildRequires:  spring2-core
BuildRequires:  spring2-test
%endif
BuildRequires:  xmltooling
BuildRequires:  xmlunit
%else
BuildRequires:  unzip
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/openws-%{namedversion}-%{release}-root

%description
Open WS.

%package javadoc
Summary:        Javadoc for openws
Group:          Development/Documentation

Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q 
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
%else
%setup -q -n openws-java -T -b 100
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export ALT_DEPLOYMENT_REPOSITORY=remote-repository::default::file://`pwd`/maven2-brew
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -DperformRelease -Denforcer.skip -Dmaven.test.skip deploy javadoc:aggregate
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p target/openws-%{namedversion}.jar %{buildroot}%{_javadir}/openws-%{namedversion}.jar
%{__cp} -p target/openws-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/openws-%{namedversion}-javadoc.jar
%{__cp} -p target/openws-%{namedversion}-sources.jar %{buildroot}%{_javadir}/openws-%{namedversion}-sources.jar
%{__cp} -p target/openws-%{namedversion}-bin.tar.gz %{buildroot}%{_javadir}/openws-%{namedversion}-bin.tar.gz
%{__cp} -p target/openws-%{namedversion}-src.tar.gz %{buildroot}%{_javadir}/openws-%{namedversion}-src.tar.gz
%{__cp} -p target/openws-%{namedversion}-bin.zip %{buildroot}%{_javadir}/openws-%{namedversion}-bin.zip
%{__cp} -p target/openws-%{namedversion}-src.zip %{buildroot}%{_javadir}/openws-%{namedversion}-src.zip
%else
%{__cp} -p %{_sourcedir}/openws-%{namedversion}.jar %{buildroot}%{_javadir}/openws-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/openws-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/openws-%{namedversion}-javadoc.jar
%{__cp} -p %{_sourcedir}/openws-%{namedversion}-sources.jar %{buildroot}%{_javadir}/openws-%{namedversion}-sources.jar
%{__cp} -p %{_sourcedir}/openws-%{namedversion}-bin.tar.gz %{buildroot}%{_javadir}/openws-%{namedversion}-bin.tar.gz
%{__cp} -p %{_sourcedir}/openws-%{namedversion}-src.tar.gz %{buildroot}%{_javadir}/openws-%{namedversion}-src.tar.gz
%{__cp} -p %{_sourcedir}/openws-%{namedversion}-bin.zip %{buildroot}%{_javadir}/openws-%{namedversion}-bin.zip
%{__cp} -p %{_sourcedir}/openws-%{namedversion}-src.zip %{buildroot}%{_javadir}/openws-%{namedversion}-src.zip
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-openws.pom
%else
%{__cp} -p %{_sourcedir}/openws-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-openws.pom
%endif

# depmap
%add_to_maven_depmap org.opensaml openws %{namedversion} JPP openws
[ %{name} = "openws" ] || %{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/openws

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/openws-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/openws-%{namedversion}
%else
%{_bindir}/unzip -qq %{_sourcedir}/openws-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/openws-%{namedversion} -x META-INF/\*
%endif
%{__ln_s} openws-%{namedversion} %{buildroot}%{_javadocdir}/openws

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc doc/CREDITS.txt doc/LICENSE.txt doc/README.txt doc/RELEASE-NOTES.txt
%{_javadir}/openws-%{namedversion}.jar
%{_javadir}/openws.jar
%{_javadir}/openws-%{namedversion}-sources.jar
%{_javadir}/openws-sources.jar
%{_javadir}/openws-%{namedversion}-bin.tar.gz
%{_javadir}/openws-bin.tar.gz
%{_javadir}/openws-%{namedversion}-src.tar.gz
%{_javadir}/openws-src.tar.gz
%{_javadir}/openws-%{namedversion}-bin.zip
%{_javadir}/openws-bin.zip
%{_javadir}/openws-%{namedversion}-src.zip
%{_javadir}/openws-src.zip
%{_mavenpomdir}/JPP-openws.pom
%{_mavendepmapfragdir}/openws

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/openws-%{namedversion}
%{_javadocdir}/openws
%{_javadir}/openws-%{namedversion}-javadoc.jar
%{_javadir}/openws-javadoc.jar

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Apr 22 2013 David Walluck <dwalluck@redhat.com> 0:1.4.2-9
- add tars to RPM

* Mon Apr 22 2013 David Walluck <dwalluck@redhat.com> 0:1.4.2-8
- add zips to RPM
- add docs to RPM
- convert to MEAD
- rerun vman
- move javadoc jars to javadoc subpackage
- bump Release to -redhat-3

* Fri Mar 01 2013 David Walluck <dwalluck@redhat.com> 0:1.4.2-7
- build javadoc and sources jars
- exclude javadoc jar
- include source jar

* Thu Sep 13 2012 David Walluck <dwalluck@redhat.com> 0:1.4.2-6
- disable tests (disables spring 2.x build dependency)
- remove xerces groupId and version properties from pom.xml
- update xerces groupId in pom and assembly xml

* Thu Sep 13 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:1.4.2-5_redhat_2
- Update pom for eap 6.0.1 parent and boms

* Mon May 14 2012 David Walluck <dwalluck@redhat.com> 0:1.4.2-4
- remove xml runtime deps from Requires and pom.xml
- add back .zip artifact to mead repo
- fix Release

* Fri May 11 2012 David Walluck <dwalluck@redhat.com> 0:1.4.2-3
- commons-httpclient is optional
- commons-codec is not even used
- use jboss-servlet-api_3.0_spec
- spring2 is not a requies as it's marked provided
- fix bad use of jpp depmap leading to invalid pom
- fix repolib file ownership
- fix javadoc requires

* Mon Nov 21 2011 Yong Yang <yyang@redhat.com> 1.4.2-2_redhat_1
- Build for Werewolf

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 1.4.2-1
- Upgrade to 1.4.2

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 1.4.1-3
- Do not create backup file because the file will be packed into src zip

* Fri Oct 21 2011 Yong Yang <yyang@redhat.com> 1.4.1-2
- Comment dependencySets in assembly src.xml, tar.gz only

* Fri Sep 30 2011 Yong Yang <yyang@redhat.com> 1.4.1-1
- Upgrade 1.4.1
- Add repolib

* Fri Jul 10 2009 David Walluck <dwalluck@redhat.com> 0:1.2.2-2
- spec cleanup

* Tue Jun 16 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.2.2-1.jpp5
- first release
